Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/diaobs.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/diaobs.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/diaobs.F90	(revision 13727)
@@ -94,5 +94,5 @@
    TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdataqc   !: Profile data after quality control
 
-   CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
+   CHARACTER(len=lca), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
 
    !!----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/find_obs_proc.h90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/find_obs_proc.h90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/find_obs_proc.h90	(revision 13727)
@@ -41,5 +41,5 @@
       ! first and last indoor i- and j-indexes      kldi, klei,   kldj, klej
       ! exclude any obs in the bottom-left overlap region
-      ! also any obs outside to whole region (defined by nlci and nlcj)
+      ! also any obs outside to whole region (defined by jpi and jpj)
       ! I am assuming that kobsp does not need to be the correct processor 
       ! number
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/grt_cir_dis.h90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/grt_cir_dis.h90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/grt_cir_dis.h90	(revision 13727)
@@ -28,6 +28,12 @@
       REAL(KIND=wp) :: pc2   !  cos(lat2) * sin(lon2)
 
+      REAL(KIND=wp) :: cosdist ! cosine of great circle distance
+
+      ! Compute cosine of great circle distance, constraining it to be between
+      ! -1 and 1 (rounding errors can take it slightly outside this range
+      cosdist = MAX( MIN( pa1 * pa2 + pb1 * pb2 + pc1 * pc2, 1.0_wp), -1.0_wp )
+
       grt_cir_dis = &
-         &  ASIN( SQRT( 1.0 - ( pa1 * pa2 + pb1 * pb2 + pc1 * pc2 )**2 ) )
+         &  ASIN( SQRT( 1.0_wp - cosdist**2.0_wp ) )
       
    END FUNCTION grt_cir_dis
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/mpp_map.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/mpp_map.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/mpp_map.F90	(revision 13727)
@@ -11,8 +11,8 @@
    !!----------------------------------------------------------------------
    USE par_kind, ONLY :   wp            ! Precision variables
-   USE par_oce , ONLY :   jpi, jpj      ! Ocean parameters
-   USE dom_oce , ONLY :   mig, mjg, nldi, nlei, nldj, nlej, nlci, nlcj, narea   ! Ocean space and time domain variables
+   USE par_oce , ONLY :   jpi, jpj, Nis0, Nie0, Njs0, Nje0   ! Ocean parameters
+   USE dom_oce , ONLY :   mig, mjg, narea                    ! Ocean space and time domain variables
 #if defined key_mpp_mpi
-   USE lib_mpp, ONLY :   mpi_comm_oce   ! MPP library
+   USE lib_mpp , ONLY :   mpi_comm_oce   ! MPP library
 #endif
    USE in_out_manager   ! I/O manager
@@ -65,5 +65,5 @@
 
 !      ! Setup local grid points
-      imppmap(mig(1):mig(nlci),mjg(1):mjg(nlcj)) = narea
+      imppmap(mig(1):mig(jpi),mjg(1):mjg(jpj)) = narea
       
       ! Get global data
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_grid.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_grid.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_grid.F90	(revision 13727)
@@ -129,5 +129,5 @@
             IF ( cdgrid == 'T' ) THEN
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             1, nlci, 1, nlcj,         &
+                  &                             1, jpi, 1, jpj,           &
                   &                             nproc, jpnij,             &
                   &                             glamt, gphit, tmask,      &
@@ -136,5 +136,5 @@
             ELSEIF ( cdgrid == 'U' ) THEN
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             1, nlci, 1, nlcj,         &
+                  &                             1, jpi, 1, jpj,           &
                   &                             nproc, jpnij,             &
                   &                             glamu, gphiu, umask,      &
@@ -143,5 +143,5 @@
             ELSEIF ( cdgrid == 'V' ) THEN
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             1, nlci, 1, nlcj,         &
+                  &                             1, jpi, 1, jpj,           &
                   &                             nproc, jpnij,             &
                   &                             glamv, gphiv, vmask,      &
@@ -150,5 +150,5 @@
             ELSEIF ( cdgrid == 'F' ) THEN
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             1, nlci, 1, nlcj,         &
+                  &                             1, jpi, 1, jpj,           &
                   &                             nproc, jpnij,             &
                   &                             glamf, gphif, fmask,      &
@@ -279,6 +279,6 @@
          zmskg(:,:) = -1.e+10
          ! Add various grids here.
-         DO jj = 1, nlcj
-            DO ji = 1, nlci
+         DO jj = 1, jpj
+            DO ji = 1, jpi
                zlamg(mig(ji),mjg(jj)) = glamt(ji,jj)
                zphig(mig(ji),mjg(jj)) = gphit(ji,jj)
@@ -684,5 +684,7 @@
          & fhistx1, fhistx2, fhisty1, fhisty2
       REAL(wp) :: histtol
-      
+      CHARACTER(LEN=26) :: clfmt            ! writing format
+      INTEGER           :: idg              ! number of digits
+ 
       IF (ln_grid_search_lookup) THEN
          
@@ -709,9 +711,10 @@
 
          IF ( ln_grid_global ) THEN
-            WRITE(cfname, FMT="(A,'_',A)") &
-               &          TRIM(cn_gridsearchfile), 'global.nc'
+            WRITE(cfname, FMT="(A,'_',A)") TRIM(cn_gridsearchfile), 'global.nc'
          ELSE
-            WRITE(cfname, FMT="(A,'_',I4.4,'of',I4.4,'by',I4.4,'.nc')") &
-               &          TRIM(cn_gridsearchfile), nproc, jpni, jpnj
+            idg = MAX( INT(LOG10(REAL(jpnij,wp))) + 1, 4 )        ! how many digits to we need to write? min=4, max=9
+            ! define the following format: "(a,a,ix.x,a,ix.x,a,ix.x,a)"
+            WRITE(clfmt, "('(a,a,i', i1, '.', i1',a,i', i1, '.', i1',a,i', i1, '.', i1',a)')") idg, idg, idg, idg, idg, idg
+            WRITE(cfname,      clfmt     ) TRIM(cn_gridsearchfile),'_', nproc,'of', jpni,'by', jpnj,'.nc'
          ENDIF
 
@@ -816,5 +819,5 @@
             
             CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,  &
-               &                     1, nlci, 1, nlcj,          &
+               &                     1, jpi, 1, jpj,            &
                &                     nproc, jpnij,              &
                &                     glamt, gphit, tmask,       &
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_oper.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_oper.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_oper.F90	(revision 13727)
@@ -189,5 +189,5 @@
          ! Initialize daily mean for first timestep of the day
          IF ( idayend == 1 .OR. kt == 0 ) THEN
-            DO_3D_11_11( 1, jpk )
+            DO_3D( 1, 1, 1, 1, 1, jpk )
                prodatqc%vdmean(ji,jj,jk,1) = 0.0
                prodatqc%vdmean(ji,jj,jk,2) = 0.0
@@ -195,5 +195,5 @@
          ENDIF
 
-         DO_3D_11_11( 1, jpk )
+         DO_3D( 1, 1, 1, 1, 1, jpk )
             ! Increment field 1 for computing daily mean
             prodatqc%vdmean(ji,jj,jk,1) = prodatqc%vdmean(ji,jj,jk,1) &
@@ -209,5 +209,5 @@
             IF (lwp) WRITE(numout,*) 'Calculating prodatqc%vdmean on time-step: ',kt
             CALL FLUSH(numout)
-            DO_3D_11_11( 1, jpk )
+            DO_3D( 1, 1, 1, 1, 1, jpk )
                prodatqc%vdmean(ji,jj,jk,1) = prodatqc%vdmean(ji,jj,jk,1) &
                   &                        * zdaystp
@@ -750,5 +750,5 @@
          ! Initialize night-time mean for first timestep of the day
          IF ( idayend == 1 .OR. kt == 0 ) THEN
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                surfdataqc%vdmean(ji,jj) = 0.0
                zmeanday(ji,jj) = 0.0
@@ -761,5 +761,5 @@
          imask_night(:,:) = INT( zouttmp(:,:) )
 
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ! Increment the temperature field for computing night mean and counter
             surfdataqc%vdmean(ji,jj) = surfdataqc%vdmean(ji,jj)  &
@@ -773,5 +773,5 @@
          IF ( idayend == 0 ) THEN
             IF (lwp) WRITE(numout,*) 'Calculating surfdataqc%vdmean on time-step: ',kt
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                ! Test if "no night" point
                IF ( icount_night(ji,jj) > 0 ) THEN
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_altbias.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_altbias.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_altbias.F90	(revision 13727)
@@ -125,5 +125,5 @@
          ! Get the Alt bias data
          
-         CALL iom_get( numaltbias, jpdom_data, 'altbias', z_altbias(:,:), 1 )
+         CALL iom_get( numaltbias, jpdom_global, 'altbias', z_altbias(:,:) )
          
          ! Close the file
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_prof.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_prof.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_prof.F90	(revision 13727)
@@ -140,7 +140,7 @@
          & zphi, &
          & zlam
-      REAL(wp), DIMENSION(:), ALLOCATABLE :: &
+      REAL(dp), DIMENSION(:), ALLOCATABLE :: &
          & zdat
-      REAL(wp), DIMENSION(knumfiles) :: &
+      REAL(dp), DIMENSION(knumfiles) :: &
          & djulini, &
          & djulend
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_surf.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_surf.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_read_surf.F90	(revision 13727)
@@ -112,7 +112,7 @@
          & zphi, &
          & zlam
-      REAL(wp), DIMENSION(:), ALLOCATABLE :: &
+      REAL(dp), DIMENSION(:), ALLOCATABLE :: &
          & zdat
-      REAL(wp), DIMENSION(knumfiles) :: &
+      REAL(dp), DIMENSION(knumfiles) :: &
          & djulini, &
          & djulend
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_readmdt.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_readmdt.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_readmdt.F90	(revision 13727)
@@ -90,5 +90,5 @@
       CALL iom_open( mdtname, nummdt )       ! Open the file
       !                                      ! Get the MDT data
-      CALL iom_get ( nummdt, jpdom_data, 'sossheig', z_mdt(:,:), 1 )
+      CALL iom_get ( nummdt, jpdom_global, 'sossheig', z_mdt(:,:) )
       CALL iom_close(nummdt)                 ! Close the file
       
@@ -215,5 +215,5 @@
       zeta2 = 0.0
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
        zdxdy = e1e2t(ji,jj) * zpromsk(ji,jj)
        zarea = zarea + zdxdy
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_sstbias.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_sstbias.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_sstbias.F90	(revision 13727)
@@ -139,5 +139,5 @@
                cl_bias_files(jtype) )
             ! Get the SST bias data
-            CALL iom_get( numsstbias, jpdom_data, 'tn', z_sstbias_2d(:,:), 1 )
+            CALL iom_get( numsstbias, jpdom_global, 'tn', z_sstbias_2d(:,:), 1 )
             z_sstbias(:,:,jtype) = z_sstbias_2d(:,:)       
             ! Close the file
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_write.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_write.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obs_write.F90	(revision 13727)
@@ -86,4 +86,6 @@
       CHARACTER(LEN=40) :: clfname
       CHARACTER(LEN=10) :: clfiletype
+      CHARACTER(LEN=12) :: clfmt            ! writing format
+      INTEGER :: idg                        ! number of digits
       INTEGER :: ilevel
       INTEGER :: jvar
@@ -181,5 +183,7 @@
       fbdata%caddname(1)   = 'Hx'
 
-      WRITE(clfname, FMT="(A,'_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
+      idg = MAX( INT(LOG10(REAL(jpnij,wp))) + 1, 4 )            ! how many digits to we need to write? min=4, max=9
+      WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg   ! '(a,a,ix.x,a)'
+      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', nproc, '.nc'
 
       IF(lwp) THEN
@@ -326,4 +330,6 @@
       CHARACTER(LEN=10) :: clfiletype
       CHARACTER(LEN=12), PARAMETER :: cpname = 'obs_wri_surf'
+      CHARACTER(LEN=12) :: clfmt           ! writing format
+      INTEGER :: idg                       ! number of digits
       INTEGER :: jo
       INTEGER :: ja
@@ -453,5 +459,7 @@
       fbdata%caddname(1)   = 'Hx'
 
-      WRITE(clfname, FMT="(A,'_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
+      idg = MAX( INT(LOG10(REAL(jpnij,wp))) + 1, 4 )            ! how many digits to we need to write? min=4, max=9
+      WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg   ! '(a,a,ix.x,a)'
+      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', nproc, '.nc'
 
       IF(lwp) THEN
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obsinter_z1d.h90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obsinter_z1d.h90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/OBS/obsinter_z1d.h90	(revision 13727)
@@ -62,29 +62,33 @@
          z1dm = ( pdep(kkco(jdep)) - pobsdep(jdep)      )
          z1dp = ( pobsdep(jdep)    - pdep(kkco(jdep)-1) )
-         IF ( pobsmask(kkco(jdep)) == 0.0_wp ) z1dp = 0.0_wp
+         
+         ! If kkco(jdep) is masked then set pobs(jdep) to the lowest value located above bathymetry
+         IF ( pobsmask(kkco(jdep)) == 0.0_wp ) THEN
+            pobs(jdep) = pobsk(kkco(jdep)-1)
+         ELSE
+            zsum = z1dm + z1dp
 
-         zsum = z1dm + z1dp
-         
-         IF ( k1dint == 0 ) THEN
+            IF ( k1dint == 0 ) THEN
 
-            !-----------------------------------------------------------------
-            !  Linear interpolation
-            !-----------------------------------------------------------------
-            pobs(jdep) = (   z1dm * pobsk(kkco(jdep)-1) &
-               &           + z1dp * pobsk(kkco(jdep)  ) ) / zsum
+               !-----------------------------------------------------------------
+               !  Linear interpolation
+               !-----------------------------------------------------------------
+               pobs(jdep) = (   z1dm * pobsk(kkco(jdep)-1) &
+                  &           + z1dp * pobsk(kkco(jdep)  ) ) / zsum
 
-         ELSEIF ( k1dint == 1 ) THEN
+            ELSEIF ( k1dint == 1 ) THEN
 
-            !-----------------------------------------------------------------
-            ! Cubic spline interpolation
-            !-----------------------------------------------------------------
-            zsum2 = zsum * zsum
-            pobs(jdep)  = (  z1dm                             * pobsk (kkco(jdep)-1) &
-               &           + z1dp                             * pobsk (kkco(jdep)  ) &
-               &           + ( z1dm * ( z1dm * z1dm - zsum2 ) * pobs2k(kkco(jdep)-1) &
-               &           +   z1dp * ( z1dp * z1dp - zsum2 ) * pobs2k(kkco(jdep)  ) &
-               &             ) / 6.0_wp                                              &
-               &          ) / zsum
+               !-----------------------------------------------------------------
+               ! Cubic spline interpolation
+               !-----------------------------------------------------------------
+               zsum2 = zsum * zsum
+               pobs(jdep)  = (  z1dm                             * pobsk (kkco(jdep)-1) &
+                  &           + z1dp                             * pobsk (kkco(jdep)  ) &
+                  &           + ( z1dm * ( z1dm * z1dm - zsum2 ) * pobs2k(kkco(jdep)-1) &
+                  &           +   z1dp * ( z1dp * z1dp - zsum2 ) * pobs2k(kkco(jdep)  ) &
+                  &             ) / 6.0_wp                                              &
+                  &          ) / zsum
 
+            ENDIF
          ENDIF
       END DO
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cpl_oasis3.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cpl_oasis3.F90	(revision 13727)
@@ -69,7 +69,4 @@
    INTEGER, PUBLIC, PARAMETER ::   nmaxcat=5    ! Maximum number of coupling fields
    INTEGER, PUBLIC, PARAMETER ::   nmaxcpl=5    ! Maximum number of coupling fields
-   LOGICAL, PARAMETER         ::   ltmp_wapatch = .TRUE.   ! patch to restore wraparound rows in cpl_send, cpl_rcv, cpl_define  
-   INTEGER                    ::   nldi_save, nlei_save
-   INTEGER                    ::   nldj_save, nlej_save
    
    TYPE, PUBLIC ::   FLD_CPL               !: Type for coupling field information
@@ -148,13 +145,4 @@
       !!--------------------------------------------------------------------
 
-      ! patch to restore wraparound rows in cpl_send, cpl_rcv, cpl_define
-      IF( ltmp_wapatch ) THEN
-         nldi_save = nldi   ;   nlei_save = nlei
-         nldj_save = nldj   ;   nlej_save = nlej
-         IF( nimpp           ==      1 ) nldi = 1
-         IF( nimpp + jpi - 1 == jpiglo ) nlei = jpi
-         IF( njmpp           ==      1 ) nldj = 1
-         IF( njmpp + jpj - 1 == jpjglo ) nlej = jpj
-      ENDIF 
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) 'cpl_define : initialization in coupled ocean/atmosphere case'
@@ -177,16 +165,14 @@
       ENDIF
       !
-      ! ... Define the shape for the area that excludes the halo
-      !     For serial configuration (key_mpp_mpi not being active)
-      !     nl* is set to the global values 1 and jp*glo.
+      ! ... Define the shape for the area that excludes the halo as we don't want them to be "seen" by oasis
       !
       ishape(1) = 1
-      ishape(2) = nlei-nldi+1
+      ishape(2) = Ni_0
       ishape(3) = 1
-      ishape(4) = nlej-nldj+1
+      ishape(4) = Nj_0
       !
       ! ... Allocate memory for data exchange
       !
-      ALLOCATE(exfld(nlei-nldi+1, nlej-nldj+1), stat = nerror)
+      ALLOCATE(exfld(Ni_0, Nj_0), stat = nerror)        ! allocate only inner domain (without halos)
       IF( nerror > 0 ) THEN
          CALL oasis_abort ( ncomp_id, 'cpl_define', 'Failure in allocating exfld')   ;   RETURN
@@ -194,21 +180,21 @@
       !
       ! -----------------------------------------------------------------
-      ! ... Define the partition 
+      ! ... Define the partition, excluding halos as we don't want them to be "seen" by oasis    
       ! -----------------------------------------------------------------
       
-      paral(1) = 2                                              ! box partitioning
-      paral(2) = jpiglo * (nldj-1+njmpp-1) + (nldi-1+nimpp-1)   ! NEMO lower left corner global offset    
-      paral(3) = nlei-nldi+1                                    ! local extent in i 
-      paral(4) = nlej-nldj+1                                    ! local extent in j
-      paral(5) = jpiglo                                         ! global extent in x
+      paral(1) = 2                                      ! box partitioning
+      paral(2) = Ni0glo * mjg0(nn_hls) + mig0(nn_hls)   ! NEMO lower left corner global offset, without halos 
+      paral(3) = Ni_0                                   ! local extent in i, excluding halos
+      paral(4) = Nj_0                                   ! local extent in j, excluding halos
+      paral(5) = Ni0glo                                 ! global extent in x, excluding halos
       
       IF( sn_cfctl%l_oasout ) THEN
          WRITE(numout,*) ' multiexchg: paral (1:5)', paral
-         WRITE(numout,*) ' multiexchg: jpi, jpj =', jpi, jpj
-         WRITE(numout,*) ' multiexchg: nldi, nlei, nimpp =', nldi, nlei, nimpp
-         WRITE(numout,*) ' multiexchg: nldj, nlej, njmpp =', nldj, nlej, njmpp
+         WRITE(numout,*) ' multiexchg: Ni_0, Nj_0 =', Ni_0, Nj_0
+         WRITE(numout,*) ' multiexchg: Nis0, Nie0, nimpp =', Nis0, Nie0, nimpp
+         WRITE(numout,*) ' multiexchg: Njs0, Nje0, njmpp =', Njs0, Nje0, njmpp
       ENDIF
    
-      CALL oasis_def_partition ( id_part, paral, nerror, jpiglo*jpjglo )
+      CALL oasis_def_partition ( id_part, paral, nerror, Ni0glo*Nj0glo )   ! global number of points, excluding halos
       !
       ! ... Announce send variables. 
@@ -316,8 +302,4 @@
 #endif
       !
-      IF( ltmp_wapatch ) THEN
-         nldi = nldi_save   ;   nlei = nlei_save
-         nldj = nldj_save   ;   nlej = nlej_save
-      ENDIF
    END SUBROUTINE cpl_define
    
@@ -337,13 +319,4 @@
       INTEGER                                   ::   jc,jm     ! local loop index
       !!--------------------------------------------------------------------
-      ! patch to restore wraparound rows in cpl_send, cpl_rcv, cpl_define
-      IF( ltmp_wapatch ) THEN
-         nldi_save = nldi   ;   nlei_save = nlei
-         nldj_save = nldj   ;   nlej_save = nlej
-         IF( nimpp           ==      1 ) nldi = 1
-         IF( nimpp + jpi - 1 == jpiglo ) nlei = jpi
-         IF( njmpp           ==      1 ) nldj = 1
-         IF( njmpp + jpj - 1 == jpjglo ) nlej = jpj
-      ENDIF
       !
       ! snd data to OASIS3
@@ -352,6 +325,6 @@
          DO jm = 1, ssnd(kid)%ncplmodel
         
-            IF( ssnd(kid)%nid(jc,jm) /= -1 ) THEN
-               CALL oasis_put ( ssnd(kid)%nid(jc,jm), kstep, pdata(nldi:nlei, nldj:nlej,jc), kinfo )
+            IF( ssnd(kid)%nid(jc,jm) /= -1 ) THEN   ! exclude halos from data sent to oasis
+               CALL oasis_put ( ssnd(kid)%nid(jc,jm), kstep, pdata(Nis0:Nie0, Njs0:Nje0,jc), kinfo )
                
                IF ( sn_cfctl%l_oasout ) THEN        
@@ -363,7 +336,7 @@
                      WRITE(numout,*) 'oasis_put:  kstep ', kstep
                      WRITE(numout,*) 'oasis_put:   info ', kinfo
-                     WRITE(numout,*) '     - Minimum value is ', MINVAL(pdata(nldi:nlei,nldj:nlej,jc))
-                     WRITE(numout,*) '     - Maximum value is ', MAXVAL(pdata(nldi:nlei,nldj:nlej,jc))
-                     WRITE(numout,*) '     -     Sum value is ',    SUM(pdata(nldi:nlei,nldj:nlej,jc))
+                     WRITE(numout,*) '     - Minimum value is ', MINVAL(pdata(Nis0:Nie0,Njs0:Nje0,jc))
+                     WRITE(numout,*) '     - Maximum value is ', MAXVAL(pdata(Nis0:Nie0,Njs0:Nje0,jc))
+                     WRITE(numout,*) '     -     Sum value is ',    SUM(pdata(Nis0:Nie0,Njs0:Nje0,jc))
                      WRITE(numout,*) '****************'
                   ENDIF
@@ -374,8 +347,4 @@
          ENDDO
       ENDDO
-      IF( ltmp_wapatch ) THEN
-         nldi = nldi_save   ;   nlei = nlei_save
-         nldj = nldj_save   ;   nlej = nlej_save
-      ENDIF
       !
     END SUBROUTINE cpl_snd
@@ -396,11 +365,6 @@
       !!
       INTEGER                                   ::   jc,jm     ! local loop index
-      LOGICAL                                   ::   llaction, llfisrt
+      LOGICAL                                   ::   llaction, ll_1st
       !!--------------------------------------------------------------------
-      ! patch to restore wraparound rows in cpl_send, cpl_rcv, cpl_define
-      IF( ltmp_wapatch ) THEN
-         nldi_save = nldi   ;   nlei_save = nlei
-         nldj_save = nldj   ;   nlej_save = nlej
-      ENDIF
       !
       ! receive local data from OASIS3 on every process
@@ -409,11 +373,5 @@
       !
       DO jc = 1, srcv(kid)%nct
-         IF( ltmp_wapatch ) THEN
-            IF( nimpp           ==      1 ) nldi = 1
-            IF( nimpp + jpi - 1 == jpiglo ) nlei = jpi
-            IF( njmpp           ==      1 ) nldj = 1
-            IF( njmpp + jpj - 1 == jpjglo ) nlej = jpj
-         ENDIF
-         llfisrt = .TRUE.
+         ll_1st = .TRUE.
 
          DO jm = 1, srcv(kid)%ncplmodel
@@ -426,14 +384,16 @@
                   &        kinfo == OASIS_RecvOut .OR. kinfo == OASIS_FromRestOut
                
-               IF ( sn_cfctl%l_oasout )   WRITE(numout,*) "llaction, kinfo, kstep, ivarid: " , llaction, kinfo, kstep, srcv(kid)%nid(jc,jm)
+               IF ( sn_cfctl%l_oasout )   &
+                  &  WRITE(numout,*) "llaction, kinfo, kstep, ivarid: " , llaction, kinfo, kstep, srcv(kid)%nid(jc,jm)
                
-               IF( llaction ) THEN
+               IF( llaction ) THEN   ! data received from oasis do not include halos
                   
                   kinfo = OASIS_Rcv
-                  IF( llfisrt ) THEN 
-                     pdata(nldi:nlei,nldj:nlej,jc) =                                 exfld(:,:) * pmask(nldi:nlei,nldj:nlej,jm)
-                     llfisrt = .FALSE.
+                  IF( ll_1st ) THEN 
+                     pdata(Nis0:Nie0,Njs0:Nje0,jc) =   exfld(:,:) * pmask(Nis0:Nie0,Njs0:Nje0,jm)
+                     ll_1st = .FALSE.
                   ELSE
-                     pdata(nldi:nlei,nldj:nlej,jc) = pdata(nldi:nlei,nldj:nlej,jc) + exfld(:,:) * pmask(nldi:nlei,nldj:nlej,jm)
+                     pdata(Nis0:Nie0,Njs0:Nje0,jc) = pdata(Nis0:Nie0,Njs0:Nje0,jc)   &
+                        &                                + exfld(:,:) * pmask(Nis0:Nie0,Njs0:Nje0,jm)
                   ENDIF
                   
@@ -444,7 +404,7 @@
                      WRITE(numout,*) 'oasis_get:   kstep', kstep
                      WRITE(numout,*) 'oasis_get:   info ', kinfo
-                     WRITE(numout,*) '     - Minimum value is ', MINVAL(pdata(nldi:nlei,nldj:nlej,jc))
-                     WRITE(numout,*) '     - Maximum value is ', MAXVAL(pdata(nldi:nlei,nldj:nlej,jc))
-                     WRITE(numout,*) '     -     Sum value is ',    SUM(pdata(nldi:nlei,nldj:nlej,jc))
+                     WRITE(numout,*) '     - Minimum value is ', MINVAL(pdata(Nis0:Nie0,Njs0:Nje0,jc))
+                     WRITE(numout,*) '     - Maximum value is ', MAXVAL(pdata(Nis0:Nie0,Njs0:Nje0,jc))
+                     WRITE(numout,*) '     -     Sum value is ',    SUM(pdata(Nis0:Nie0,Njs0:Nje0,jc))
                      WRITE(numout,*) '****************'
                   ENDIF
@@ -456,11 +416,6 @@
          ENDDO
 
-         IF( ltmp_wapatch ) THEN
-            nldi = nldi_save   ;   nlei = nlei_save
-            nldj = nldj_save   ;   nlej = nlej_save
-         ENDIF
-         !--- Fill the overlap areas and extra hallows (mpp)
-         !--- check periodicity conditions (all cases)
-         IF( .not. llfisrt ) THEN
+         !--- we must call lbc_lnk to fill the halos that where not received.
+         IF( .NOT. ll_1st ) THEN
             CALL lbc_lnk( 'cpl_oasis3', pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
          ENDIF
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cyclone.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cyclone.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/cyclone.F90	(revision 13727)
@@ -147,5 +147,5 @@
             zb = 2.
 
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
 
                ! calc distance between TC center and any point following great circle
@@ -208,5 +208,5 @@
             ENDIF           
         
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                                
                zzrglam = rad * glamt(ji,jj) - zrlon
